function rbt = robot()
%% ROBOT creates the robot used in simulations
%
% Outputs:
%
%   RBT                     Description of argument RBT
%
% Authors:
%   Philipp Tempel <philipp.tempel@ls2n.fr>



%% Parse arguments

% ROBOT()
narginchk(0, 0);

% RBT = ROBOT(___)
nargoutchk(1, 1);



%% Algorithm

% Pool noodle parameters
d = 0.07;
r = d / 2;
A = pi * r ^ 2;
J = diag(pi / 4 * r ^ 4 * [ 2 ; 1 ; 1 ]);
% Polyethylene foam
E = 0.00025 * 1e9; % GPa
G = 0.00040 * 1e9; % GPa
rho = 750;
H = hookeanMatrix(A, J, E, G);
D = 1 * 1e-3 * H;
M = spatialInertiaMatrix(rho .* A, rho .* J, zeros(3, 1));

rbt = LocomotorSMMS('Name', 'TRO(V4)');
rbt.Gravity = [ 0.0 ; 0.0 ; 0.0 ];

% Mass of the cuboids
m = [ 1 , 1 , 1 ];
% Geometric dimensions of cuboids
w = [ 0.1 , 0.1 , 0.1 ];
h = [ 0.1 , 0.1 , 0.1 ];
d = [ 0.1 , 0.1 , 0.1 ];

% First body (red)
bdy1 = RigidBody( ...
    'Name', 'Body 0' ...
  , 'SpatialInertiaMatrix', cuboid(m(1), w(1), d(1), h(1)) ...
  , 'Visual'              , tro.visual.drone() ...
  , 'Joint', FreeJoint( ...
      'Name', 'FreeEnd' ...
    , 'JointToParentTransform', tformzeros() ...
    , 'BodyToJointTransform'  , tformzeros() ...
  ) ...
);
addBody(rbt, bdy1, rbt.Ground.Name);

% Inner body (green)
bdy2 = RigidBody( ...
    'Name', 'Body 3' ...
  , 'SpatialInertiaMatrix', cuboid(m(2), w(2), d(2), h(2)) ...
  , 'Visual'              , tro.visual.body(w(2), d(2), h(2)) ...
  , 'Joint', Poolnoodle( ...
      'Name', 'PoolnoodleLeft' ...
    , 'JointToParentTransform', tformzeros() ...
    , 'BodyToJointTransform'  , tformzeros() ...
    , 'HookeanMatrix'         , H ...
    , 'DampingMatrix'         , D ...
    , 'SpatialInertiaMatrix'  , M ...
    , 'Styling'               , tro.visual.jointRod( ...
        'FaceColor', rgblighter(color('MatteGreen'), 0.10) ...
      , 'EdgeColor', color('MatteGreen') ...
    ) ...
  ) ...
);
addBody(rbt, bdy2, bdy1.Name);

% Outer body (blue)
bdy3 = RigidBody( ...
    'Name', 'Body 6' ...
  , 'SpatialInertiaMatrix', cuboid(m(3), w(3), d(3), h(3)) ...
  , 'Visual'              , tro.visual.drone() ...
  , 'Joint', Poolnoodle( ...
      'Name', 'PoolnoodleRight' ...
    , 'JointToParentTransform', tformzeros() ...
    , 'BodyToJointTransform'  , tformzeros() ...
    , 'HookeanMatrix'         , H ...
    , 'DampingMatrix'         , D ...
    , 'SpatialInertiaMatrix'  , M ...
    , 'Styling'               , tro.visual.jointRod( ...
        'FaceColor', rgblighter(color('PictonBlue'), 0.10) ...
      , 'EdgeColor', color('PictonBlue') ...
    ) ...
  ) ...
);
addBody(rbt, bdy3, bdy2.Name);


end


function M = cuboid(m, w, d, h)
%% CUBOID


moi = 1 / 12 .* m .* diag([ d*d + h*h , w*w + h*h , w*w + d*d ]);

M = blkdiag(moi, m .* eye(3, 3));

end

%------------- END OF CODE --------------
% Please send suggestions for improvement of this file to the original author as
% can be found in the header. Your contribution towards improving this function
% will be acknowledged in the "Changelog" section of the header.
